//
// © Copyright 2020 David Vines
//
// Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
//
// 1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
// 
// 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer
//    in the documentation and/or other materials provided with the distribution.
// 
// 3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived 
//    from this software without specific prior written permission.
// 
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
// COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
// DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
// OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
/* globals Capture: true, Subclass: true */
/* jshint esnext: true, debug: true */

Capture = {
    exception: function(id, f, them, ...args) {
        try {
            f.apply(them,args);
        } catch (ex) {
            debugger;
            var exdiv = document.getElementById("djvRomseySignalBox-"+id+"-exception");
            exdiv.classList.remove("hide");
            exdiv.classList.add("show");
            var element = document.getElementById("djvRomseySignalBox-"+id+"-exception.text");
            var text;
            if (ex instanceof Error) {
                text = ex.name + " : " + ex.message;
            } else {
                text = ex.toString();
            }
            text = text + '\n' + (ex.stack || ex.stacktrace || '');
    
            // Remove the chunk in the stack trace between @ and /js/
            text = text.replace(/@.*\/js\//g, " in ");
            // And version field too
            text = text.replace(/\?ver=[0-9a-fA-F]*:/g, ":");
            if (element.hasChildNodes()) {
                element.firstChild.appendData("\n"+text);
            } else {
                element.appendChild(document.createTextNode(text));
            }
        }
    }
};

Subclass = {
    make: function(child,parent) {
        child.prototype = Object.create(parent.prototype);
        Object.defineProperty(child.prototype,'constructor', {
            value: child, enumerable: false, writable: true
        });
    }
};